//---------------------------------------------------------------------------
#ifndef LinkedList2H
#define LinkedList2H
//---------------------------------------------------------------------------
class TListNode {
	friend class TList; // make TList a friend to have the access to private members
private:
	int Data;
	TListNode *nextPtr;
public:
	TListNode();
	~TListNode();
	int getData() const { return Data; };
	TListNode* getNextPtr() const { return nextPtr; };
};

class TList {
public:
	TListNode *firstPtr;
	TListNode *lastPtr;
public:
	TList();
	~TList();
	bool isEmpty() const { return firstPtr == NULL; }; // inline metoda
	void insertAtFront(const int &);
	void insertBeforeElement(const int &);
	void insertAtBack(const int &);
	int removeFromFront(int &);
	int removeFromBack(int &);
	void sortElements();
	void print() const; // Cvicenie: skuste miesto print() pretazit operator <<
};
#endif