// linked_list.cpp
//
#ifdef _WIN32
	#include <tchar.h>
	#include <conio.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <iostream>
using namespace std;

#include "LinkedList2.h"

void my_getch();
//---------------------------------------------------------------------------
int _tmain(int argc, _TCHAR* argv[])
{
	int choice, data;
	TList* integerList = new TList();

	cout << "\nEnter one of the following:" << endl
		<< "  1 to insert at beginning of list" << endl
		<< "  2 to insert at end of list" << endl
		<< "  3 to delete from beginning of list " << endl
		<< "  4 to delete from end of list " << endl
		<< "  5 to sort in the order from the smallest to the biggest" << endl
		<< "  6 to insert in the order from the smallest to the biggest" << endl
		<< "  7 to end list processing" << endl << endl;

	do {
		do {
			cout << "? ";
			cin >> choice;
		} while (choice < 1 || choice > 7);

		switch (choice) {
		case 1:
			cout << "Enter an integer : ";
			cin >> data;
			integerList->insertAtFront(data);
			integerList->print();
			break;
		case 2:
			cout << "Enter an integer : ";
			cin >> data;
			integerList->insertAtBack(data);
			integerList->print();
			break;
		case 3:
			if (!integerList->isEmpty()) {
				if (integerList->removeFromFront(data))
					cout << data << " removed from list" << endl;
				integerList->print();
				break;
			}
		case 4:
			if (!integerList->isEmpty()) {
				if (integerList->removeFromBack(data))
					cout << data << " removed from list" << endl;
				integerList->print();
			}
			break;
		case 5:
			integerList->sortElements();
			integerList->print();
			break;
		case 6:
			cout << "Enter an integer : ";
			cin >> data;
			integerList->insertBeforeElement(data);
			integerList->print();
			break;
		default: break;
		}
	} while (choice != 7);

	delete integerList;

	my_getch();
	return 0;
}
//---------------------------------------------------------------------------
void my_getch()
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------
